/* util.h
   Stephen Sorkin
   This file contains useful utilities that don't belong in classes.
   */

#include <iostream.h>
#include "distance/dist.h"

extern bool verbose_input;
extern bool verbose_output;

/* This function reads an ordered triple into a point, disregarding the z
   component of the data.
   */

istream& operator>>(istream& in, Point2& point);

/* This function returns the area of the triangle determined by the given 
   points.  This is a signed area so that it can be used to determine the
   direction of the cycle.
   */
double area2(const Point2& a, const Point2& b, const Point2& c);


/* This functions determines whether the third point is to the left of (or
   on) the directed line specified by the first two points.  It simply 
   determines whether the signed area of the triangle is consistent with
   the points being counterclockwise (or also collinear).
   */
bool left(const Point2& a, const Point2& b, const Point2& c);
bool leftOn(const Point2& a, const Point2& b, const Point2& c);

/* This function returns the larger of the two doubles specified.
 */
double max(double a, double b);

double min(double a, double b);


